#!/usr/bin/python
# coding: utf-8

import os, sys, public

_title = '检查nginx配置文件是否被挂马'
_version = 1.0  # 版本
_ps = "检查nginx配置文件是否被挂马"  # 描述
_level = 3  # 风险级别： 1.提示(低)  2.警告(中)  3.危险(高)
_date = '2023-11-21'  # 最后更新时间
_ignore = os.path.exists("data/warning/ignore/sw_nginx_malware.pl")
_tips = [
    "根据提示找到nginx配置文件，删除js挂马内容",
    "重启nginx服务"
]
_help = ''
_remind = '手动修复之前建议先把该配置文件做备份，以防操作失误导致服务无法启动；或者使用一键修复'


def check_run():
    '''
        @name 开始检测
        @author lwh<2023-11-21>
        @return tuple (status<bool>,msg<string>)
    '''
    import glob
    path = '/www/server/panel/vhost/nginx/'
    risk_file = []
    for filename in glob.glob(os.path.join(path, '*.conf')):
        if os.path.isdir(filename):
            continue
        output = public.ReadFile(filename)
        if "sub_filter" in output:
            risk_file.append(filename)
    if len(risk_file) > 0:
        return False, '以下nginx文件存在挂马内容：{}'.format('、'.join(risk_file))
    return True, '无风险'
